"""
    Production API

    API exposing endpoints for managing well headers and daily production.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

import nulltype  # noqa: F401

from openapi_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


class DailyProductionInput(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'uwi': (str,),  # noqa: E501
            'datetime': (datetime,),  # noqa: E501
            'liquid_rate': (float,),  # noqa: E501
            'oil_production_rate': (float,),  # noqa: E501
            'gas_production_rate': (float,),  # noqa: E501
            'water_production_rate': (float,),  # noqa: E501
            'choke': (float,),  # noqa: E501
            'gas_oil_ratio': (float,),  # noqa: E501
            'water_cut': (float,),  # noqa: E501
            'tubing_pressure': (float,),  # noqa: E501
            'casing_pressure': (float,),  # noqa: E501
            'gas_injection_rate': (float,),  # noqa: E501
            'operating_frequency': (float,),  # noqa: E501
            'strokes_per_minute': (float,),  # noqa: E501
            'downtime_hours': (float,),  # noqa: E501
            'downtime_code': (int,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'uwi': 'uwi',  # noqa: E501
        'datetime': 'datetime',  # noqa: E501
        'liquid_rate': 'liquidRate',  # noqa: E501
        'oil_production_rate': 'oilProductionRate',  # noqa: E501
        'gas_production_rate': 'gasProductionRate',  # noqa: E501
        'water_production_rate': 'waterProductionRate',  # noqa: E501
        'choke': 'choke',  # noqa: E501
        'gas_oil_ratio': 'gasOilRatio',  # noqa: E501
        'water_cut': 'waterCut',  # noqa: E501
        'tubing_pressure': 'tubingPressure',  # noqa: E501
        'casing_pressure': 'casingPressure',  # noqa: E501
        'gas_injection_rate': 'gasInjectionRate',  # noqa: E501
        'operating_frequency': 'operatingFrequency',  # noqa: E501
        'strokes_per_minute': 'strokesPerMinute',  # noqa: E501
        'downtime_hours': 'downtimeHours',  # noqa: E501
        'downtime_code': 'downtimeCode',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, uwi, datetime, liquid_rate, oil_production_rate, gas_production_rate, water_production_rate, choke, gas_oil_ratio, water_cut, tubing_pressure, casing_pressure, gas_injection_rate, operating_frequency, strokes_per_minute, downtime_hours, downtime_code, *args, **kwargs):  # noqa: E501
        """DailyProductionInput - a model defined in OpenAPI

        Args:
            uwi (str):
            datetime (datetime):
            liquid_rate (float):
            oil_production_rate (float):
            gas_production_rate (float):
            water_production_rate (float):
            choke (float):
            gas_oil_ratio (float):
            water_cut (float):
            tubing_pressure (float):
            casing_pressure (float):
            gas_injection_rate (float):
            operating_frequency (float):
            strokes_per_minute (float):
            downtime_hours (float):
            downtime_code (int):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.uwi = uwi
        self.datetime = datetime
        self.liquid_rate = liquid_rate
        self.oil_production_rate = oil_production_rate
        self.gas_production_rate = gas_production_rate
        self.water_production_rate = water_production_rate
        self.choke = choke
        self.gas_oil_ratio = gas_oil_ratio
        self.water_cut = water_cut
        self.tubing_pressure = tubing_pressure
        self.casing_pressure = casing_pressure
        self.gas_injection_rate = gas_injection_rate
        self.operating_frequency = operating_frequency
        self.strokes_per_minute = strokes_per_minute
        self.downtime_hours = downtime_hours
        self.downtime_code = downtime_code
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
